From 6219f0b9ab88a2da902f58a171ee74c1ea200a6e Mon Sep 17 00:00:00 2001
From: "devang.dixit" <devang.dixit@volansystech.com>
Date: Fri, 9 Apr 2021 12:53:22 +0530
Subject: [PATCH] PATCH_TO_PRINT_TM

Signed-off-by: devang.dixit <devang.dixit@volansystech.com>
---
 drivers/rtc/rtc-pcf85263.c | 197 ++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 193 insertions(+), 4 deletions(-)

diff --git a/drivers/rtc/rtc-pcf85263.c b/drivers/rtc/rtc-pcf85263.c
index dee243d..cc93ac3 100644
--- a/drivers/rtc/rtc-pcf85263.c
+++ b/drivers/rtc/rtc-pcf85263.c
@@ -24,8 +24,28 @@
 #define REG_STOP 	0x2E
 #define RTC_STOP 	0x01
 
-#define REG_SECONDS  0x01
-#define REG_SECONDS_OS (1 << 7)
+#define REG_BATT_SW     0x26
+#define VAL_BSM_VTH     0x00
+#define VAL_BSM_VBAT    (1<<1)
+#define VAL_BSM_HI      (1<<2)
+#define VAL_BSM_LW      (1<<1)|(1<<2)
+#define VAL_BSTH_V1_5   0x00
+#define VAL_BSTH_V2_8   0x01
+
+#define REG_FLAG_RG     0x2B
+#define VAL_BSF_CLR     0x00
+
+#define REG_TSR_MODE    0x23
+#define VAL_TSR3_FB     (1<<5)
+#define VAL_TSR3_FB_CLR ~(1<<2) 
+#define VAL_TSR3_LB     (1<<6) 
+#define VAL_TSR1_TS_FE  0x01 
+#define VAL_TSR1_TS_LE  0x10 
+
+#define REG_TSR3_SECONDS  0x1D
+
+#define REG_SECONDS     0x01
+#define REG_SECONDS_OS  (1 << 7)
 
 #define REG_MINUTES  0x02
 #define REG_HOURS    0x03
@@ -34,6 +54,17 @@
 #define REG_MONTHS   0x06
 #define REG_YEARS    0x07
 
+//#define RTC_RD_BSF      _IOR('p', 0x15, struct rtc_bsf_timestamp) /* Custom IOCTL command to read BSF-Flag */
+#define RTC_RD_BSF      _IOR('p', 0x15, int) /* Custom IOCTL command to read BSF-Flag */
+
+
+struct rtc_bsf_timestamp {
+        u8 bsf_flag;
+        struct rtc_time tm;
+};
+
+struct rtc_bsf_timestamp bsf;
+
 struct pcf85263 {
 	struct rtc_device *rtc;
 };
@@ -136,6 +167,93 @@ static int pcf85263_start_rtc(struct i2c_client *client)
 	return 0;
 }
 
+static int pcf85263_rtc_config_batt_sw(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+/*
+        // Configure to switch it on VBAT
+	err = pcf85263_read(client, REG_BATT_SW, &value);
+	if (err < 0)
+		return err;
+
+	value &= VAL_BSM_VBAT;
+
+	err = pcf85263_write(client, REG_BATT_SW, value);
+	if (err < 0)
+		return err;
+*/
+        // Configure TSR to store Batt SW timestamp
+	err = pcf85263_read(client, REG_TSR_MODE, &value);
+	if (err < 0)
+		return err;
+
+        if(value&VAL_TSR3_LB) {
+	    printk("RTC TSR3 already configured to store SW timestamp\n");
+		return 0;
+	}
+	value &= VAL_TSR3_LB;
+	
+	err = pcf85263_write(client, REG_TSR_MODE, value);
+	if (err < 0)
+		return err;
+
+	return 0;
+
+}
+
+static int pcf85263_rtc_read_bsf_flag(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+	err = pcf85263_read(client, REG_FLAG_RG, &value);
+	if (err < 0)
+		return err;
+        bsf.bsf_flag = value;
+        printk("-----BSF Value = %x----\n", value);
+	return 0;
+}
+
+static int pcf85263_rtc_clear_bsf_flag(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+        err = pcf85263_read(client, REG_FLAG_RG, &value);
+	if (err < 0)
+		return err;
+
+        value &= VAL_BSF_CLR;
+
+	err = pcf85263_write(client, REG_FLAG_RG, value);
+	if (err < 0)
+		return err;
+        printk("RTC BSF flag clear success\n");
+        bsf.bsf_flag = value;
+	return 0;
+}
+
+
+static int pcf85263_rtc_clear_tsr3f(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+        err = pcf85263_read(client, REG_FLAG_RG, &value);
+	if (err < 0)
+		return err;
+
+        value &= VAL_TSR3_FB_CLR;
+
+	err = pcf85263_write(client, REG_FLAG_RG, value);
+	if (err < 0)
+		return err;
+        printk("RTC TSR3F flag clear success\n");
+	return 0; 
+}
+
 static int pcf85263_rtc_read_time(struct device *dev, struct rtc_time *tm)
 {
 	struct i2c_client *client = to_i2c_client(dev);
@@ -231,13 +349,65 @@ static int pcf85263_rtc_set_time(struct device *dev, struct rtc_time *tm)
 	return pcf85263_start_rtc(client);
 }
 
+static int pcf85263_rtc_read_timestamp3(struct i2c_client *client, struct rtc_time *tm)
+{
+	// struct i2c_client *client = to_i2c_client(dev);
+	u8 start = REG_TSR3_SECONDS, regs[7];
+	struct i2c_msg msgs[2];
+	int err;
+
+	msgs[0].addr = client->addr;
+	msgs[0].flags = 0;
+	msgs[0].len = 1;
+	msgs[0].buf = &start;
+
+	msgs[1].addr = client->addr;
+	msgs[1].flags = I2C_M_RD;
+	msgs[1].len = sizeof(regs);
+	msgs[1].buf = regs;
+
+	err = i2c_transfer(client->adapter, msgs, ARRAY_SIZE(msgs));
+	if (err < 0) {
+                printk("I2C RTC timestamp read failed err= %d\n", err);
+		return err;
+        }
+        printk("I2C RTC timestamp read success err= %d\n", err);
+
+	tm->tm_sec = bcd2bin(regs[0] & 0x7f);
+	tm->tm_min = bcd2bin(regs[1] & 0x7f);
+	tm->tm_hour = bcd2bin(regs[2] & 0x3f);
+	tm->tm_mday = bcd2bin(regs[3] & 0x3f);
+	tm->tm_mon = bcd2bin(regs[5] & 0x1f);
+	tm->tm_year = bcd2bin(regs[6]) + 100;
+        printk("timestamp: sec = %d, min = %d hr = %d mday = %d mon = %d year = %d\n",
+                tm->tm_sec, tm->tm_min, tm->tm_hour, tm->tm_mday, tm->tm_mon, tm->tm_year);
+	return rtc_valid_tm(tm);
+}
+
 #ifdef CONFIG_RTC_INTF_DEV
 static int pcf85263_rtc_ioctl(struct device *dev, unsigned int cmd,
 			     unsigned long arg)
 {
+	struct i2c_client *client = to_i2c_client(dev);
+	int err;
+
 	switch (cmd) {
-	default:
-		return -ENOIOCTLCMD;
+		case RTC_RD_BSF:
+			if(bsf.bsf_flag) {
+				printk("Copying bsf to user space\n");
+				//if(copy_to_user((void __user*)arg, &bsf, sizeof(struct rtc_bsf_timestamp)))
+				if(copy_to_user((void __user*)arg, &bsf.bsf_flag, sizeof(u8)))
+					return -EFAULT;
+				printk("Copy to user space success\n");
+				err = pcf85263_rtc_clear_bsf_flag(client);
+				if(err < 0)
+					printk("RTC BSF flag clear failed\n");
+				else
+					printk("RTC BSF Clear success\n");
+			}
+			break;
+		default:
+			return -ENOIOCTLCMD;
 	}
 }
 #else
@@ -275,6 +445,25 @@ static int pcf85263_probe(struct i2c_client *client,
 	i2c_set_clientdata(client, pcf);
 	printk("RTC driver probe done\n");
 
+        err = pcf85263_rtc_config_batt_sw(client);
+        if(err < 0)
+	    printk("RTC BATT SW config failed\n");
+	else
+	    printk("RTC BATT SW config Success\n");
+		
+        err = pcf85263_rtc_read_bsf_flag(client);
+	if(err < 0)
+	    printk("RTC bsf flag read failed");
+	else
+	    printk("RTC BSF Flag read success\n");
+	
+	if(bsf.bsf_flag) {
+		err = pcf85263_rtc_read_timestamp3(client, &bsf.tm);
+		if(err < 0)
+			printk("RTC read TSR3 failed err = %d\n", err);
+		else
+		    printk("RTC read TSR3 Success\n");
+	}
 	return 0;
 }
 
-- 
2.7.4

